/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package session;

import entities.Customer;
import java.util.List;
import javax.ejb.Stateless;
import javax.ejb.LocalBean;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 *
 * @author mbuffa
 */
@Stateless
@LocalBean
public class CustomerManager {
    @PersistenceContext(unitName = "TP1Nice2015-ejbPU")
    private EntityManager em;

    public void persist(Object object) {
        // Fait un insert dans la base correspondant au unitName
        em.persist(object);
    }

    // Add business logic below. (Right-click in editor and choose
    // "Insert Code > Add Business Method")
    
    // Une méthode qui fait select *
    public List<Customer> getAllCustomers() {
        //Query q = em.createQuery("select c from Customer c");
        Query q = em.createNamedQuery("Customer.findAll");
        List<Customer> l =  q.getResultList();
        
        return l;
    }
    
    public List<Customer> getAllCustomers(int start, int nb, String sortOrder) {
        //Query q = em.createQuery("select c from Customer c");
       Query q = null;
       
        if(sortOrder.isEmpty()) {
           q= em.createQuery("select c from Customer c");
        } else if (sortOrder.equals("ASCENDING")) {
            q= em.createQuery("select c from Customer c order by c.name ASC");
        } else {
            q= em.createQuery("select c from Customer c order by c.name DESC");
        }
        q.setFirstResult(start);
        q.setMaxResults(nb);
        List<Customer> l =  q.getResultList();
        
        return l;
    }
    
    public int getNbCustomers() {
        Query q = em.createQuery("select count(c) from Customer c");
        return ((Number) q.getSingleResult()).intValue();
    }
}
